<?php
if ( ! defined( 'ABSPATH' ) ) exit;

function nwm_settings_page() {
		
	$options = get_option( 'nwm_settings' );
	?>
    <div class="wrap">
        <div id="nwm-wrap">
            <h2><?php _e( 'Nomad World Map Settings', 'nwm' ); ?></h2>
          	<?php if ( ( isset( $_GET['settings-updated'] ) && $_GET['settings-updated'] == 'true' ) ) { ?>
            	<div id="message" class="message updated"><p><strong><?php _e( 'Settings updated', 'nwm' ) ?></strong></p></div>
            <?php } ?>
            <form id="nwm-settings-form" action="options.php" method="post">
                <div class="postbox-container">
                    <div class="metabox-holder">
                        <div class="postbox">
                            <div title="Click to toggle" class="handlediv"><br></div>
                            <h3 class="hndle"><span><?php _e( 'General', 'nwm' ); ?></span></h3>
                            <div class="inside">
                                <p>
                                   <label for="nwm-flightpath"><?php _e( 'Draw lines between the markers?', 'nwm' ); ?></label> 
                                   <input id="nwm-flightpath" type="checkbox" name="nwm-flightpath" value="" <?php checked( $options['flightpath'] == '1', true ); ?> />
                                </p>
                                <p <?php if ( $options['flightpath'] != '1' ) { echo 'style="display:none;"'; } ?>   class="nwm-curved-option">
                                   <label for="nwm-curved-lines"><?php _e( 'Draw curved lines on the map?', 'nwm' ); ?></label> 
                                   <input id="nwm-curved-lines" type="checkbox" name="nwm-curved-lines" value="" <?php checked( $options['curved_lines'] == '1', true ); ?> />
                                </p>  
                                <p>
                                   <label for="nwm-round-thumbs"><?php _e( 'Show the post thumbnails in a circle?', 'nwm' ); ?></label> 
                                   <input id="nwm-round-thumbs" type="checkbox" name="nwm-round-thumbs" value="" <?php checked( $options['round_thumbs'] == '1', true ); ?> />
                                </p>            
                                <p>
                                    <label for="nwm-zoom-to"><?php _e( 'On pageload zoom to:', 'nwm' ); ?></label> 
                                    <?php echo nwm_zoom_to( $options ); ?>
                                </p>
                                <p>
                                    <label for="nwm-zoom-level"><?php _e( 'Zoom level:', 'nwm' ); ?></label> 
                                    <?php echo nwm_zoom_level( $options ); ?>
                                </p>
                                <p>
                                    <label for="nwm-map-type"><?php _e( 'Map type:', 'nwm' ); ?></label> 
                                    <?php echo nwm_map_types( $options ); ?>
                                </p>
                                <div class="nwm-marker-lines">
                                    <label for="nwm-past-color"><?php _e( 'Past route color:', 'nwm' ); ?></label> 
                                    <input type="text" name="nwm-past-color" value="<?php echo esc_attr( $options['past_color'] ); ?>" id="nwm-past-color" />
                                </div>
                                <div class="nwm-marker-lines">
                                    <label for="nwm-future-color"><?php _e( 'Future route color:', 'nwm' ); ?></label> 
                                    <input type="text" name="nwm-future-color" value="<?php echo esc_attr( $options['future_color'] ); ?>" id="nwm-future-color" />
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="metabox-holder">
                        <div class="postbox">
                            <div title="Click to toggle" class="handlediv"><br></div>
                            <h3 class="hndle"><span><?php _e( 'Map Controls', 'nwm' ); ?></span></h3>
                            <div class="inside">
                                <p>
                                   <label for="nwm-streetview"><?php _e( 'Show the street view controls?', 'nwm' ); ?></label> 
                                   <input id="nwm-streeview" type="checkbox" name="nwm-streetview" value="" <?php checked( $options['streetview'] == '1', true ); ?> />
                                </p> 
                                <p>
                                    <label><?php _e( 'Position of the map controls', 'nwm' ); ?></label>
                                    <span class="nwm-radioboxes">
                                        <input type="radio" id="nwm-control-left" name="nwm-control-position" <?php checked( 'left', $options['control_position'], true ); ?> value="left" />
                                        <label for="nwm-control-left"><?php _e( 'Left', 'nwm' ); ?></label>
                                        <input type="radio" id="nwm-control-right" name="nwm-control-position" <?php checked( 'right', $options['control_position'], true ); ?> value="right" />
                                        <label for="nwm-control-right"><?php _e( 'Right', 'nwm' ); ?></label>
                                    </span>
                                </p>
                                <p>
                                    <label><?php _e( 'Zoom control style', 'nwm' ); ?></label>
                                    <span class="nwm-radioboxes">
                                        <input type="radio" id="nwm-small-style" name="nwm-control-style" <?php checked( 'small', $options['control_style'], true ); ?> value="small" />
                                        <label for="nwm-small-style"><?php _e( 'Small', 'nwm' ); ?></label>
                                        <input type="radio" id="nwm-large-style" name="nwm-control-style" <?php checked( 'large', $options['control_style'], true ); ?> value="large" />
                                        <label for="nwm-large-style"><?php _e( 'Large', 'nwm' ); ?></label>
                                    </span>
                                </p>
                            </div>        
                        </div>   
                    </div>  
                </div>   
                
                <div class="postbox-container side">
                	<div class="metabox-holder">
                        <div class="postbox">
                            <div title="Click to toggle" class="handlediv"><br></div>
                            <h3 class="hndle"><span><?php _e( 'About', 'nwm' ); ?></span><span style="float:right;">Version <?php echo NWN_VERSION_NUM; ?></span></h3>
                            <div class="inside">
                                <p><strong>Nomad World Map</strong> by <a href="http://twitter.com/tijmensmit">Tijmen Smit</a>.</p>
                                <p>If you like this plugin, please rate it <strong>5 stars</strong> on <a href="http://wordpress.org/plugins/nomad-world-map/">WordPress.org</a>.
                            </div>
                        </div>
                	</div>        
                </div>
 
                <p class="nwm-update-btn"><input id="nwm-add-trip" type="submit" name="nwm-add-trip" class="button-primary" value="<?php _e( 'Update Settings', 'nwm' ); ?>" /></p>
                <?php settings_fields( 'nwm_settings' ); ?>
            </form>
        </div>
    </div>    
    <?php
	
}

/* Process the map settings */
function nwm_settings_check() {
	
	$output = array();
	$zoom_options = array( 'first', 'schedule_start', 'last' );
	$map_types = array( 'roadmap', 'satellite', 'hybrid', 'terrain' );
		
	/* Check if we have a valid zoom-to option, otherwise set it to last */
	if ( in_array( $_POST['nwm-zoom-to'], $zoom_options ) ) {
		$output['zoom_to'] = wp_filter_nohtml_kses( $_POST['nwm-zoom-to'] );
	} else {
		$output['zoom_to'] = 'last';
	}
	
	/* Check if we have a valid map type, otherwise set it to last */
	if ( in_array( $_POST['nwm-map-type'], $map_types ) ) {
		$output['map_type'] = wp_filter_nohtml_kses( $_POST['nwm-map-type'] );
	} else {
		$output['map_type'] = 'roadmap';
	}
	
	/* Check if we have a valid zoom level, it has to be between 1 or 12. If not set it to the default of 3 */
	if ( $_POST['nwm-zoom-level'] >= 1 || $_POST['nwm-zoom-level'] <= 12 ) {
		$output['zoom_level'] = $_POST['nwm-zoom-level'];
	} else {
		$output['zoom_level'] = 3;	
	}	

	$output['flightpath'] = isset( $_POST['nwm-flightpath'] ) ? 1 : 0;
	$output['curved_lines'] = isset( $_POST['nwm-curved-lines'] ) ? 1 : 0;		
	$output['round_thumbs'] = isset( $_POST['nwm-round-thumbs'] ) ? 1 : 0;	
	$output['past_color'] = sanitize_text_field( $_POST['nwm-past-color'] );
	$output['future_color'] = sanitize_text_field( $_POST['nwm-future-color'] );
	$output['streetview'] = isset( $_POST['nwm-streetview'] ) ? 1 : 0;	
	$output['control_position'] = ( wp_filter_nohtml_kses( $_POST['nwm-control-position']  == 'left') ) ? 'left' : 'right';	
	$output['control_style'] = ( wp_filter_nohtml_kses( $_POST['nwm-control-style'] == 'small' ) ) ? 'small' : 'large';
	
	nwm_delete_all_transients();
	
	return $output;
	
}

/* Create the dropdown to select which marker is active when the page first loads */
function nwm_zoom_to( $options ) {
	
	$items = array( 'first' => 'The first location (default)', 
				    'schedule_start' => 'The last location before your scheduled route starts',
				    'last' => 'The last location',
				   );
				   
	$dropdown = '<select id="nwm-zoom-to" name="nwm-zoom-to">';
	
	foreach ( $items as $item => $value ) {
		$selected = ( $options['zoom_to'] == $item ) ? 'selected="selected"' : '';
		$dropdown .= "<option value='$item' $selected>$value</option>";
	}
	
	$dropdown .= "</select>";
	
	return $dropdown;
	
}

/* Create the dropdown for the different map types */
function nwm_map_types( $options ) {
	
	$items = array( 'roadmap', 'satellite', 'hybrid', 'terrain' );
	$dropdown = '<select id="nwm-map-type" name="nwm-map-type">';
	
	foreach ( $items as $item => $value ) {
		$selected = ( $options['map_type'] == $value ) ? 'selected="selected"' : '';
		$dropdown .= "<option value='$value' $selected>" . ucfirst( $value ) . "</option>";
	}
	
	$dropdown .= "</select>";
	
	return $dropdown;
	
}

/* Create the dropdown to select the zoom level */
function nwm_zoom_level( $options ) {
					   
	$dropdown = '<select id="nwm-zoom-level" name="nwm-zoom-level">';
	
	for ( $i = 1; $i < 13; $i++ ) {
        $selected = ( $options['zoom_level'] == $i ) ? 'selected="selected"' : '';
		
		switch ( $i ) {
			case '1':
				$zoom_desc = '- World view';
				break;
			case '3':
				$zoom_desc = '- Default';
				break;
			case '12':
				$zoom_desc = '- Roadmap view';
				break;	
			default:
				$zoom_desc = '';		
		}

		$dropdown .= "<option value='$i' $selected>$i $zoom_desc</option>";	
    }
		
	$dropdown .= "</select>";
		
	return $dropdown;
	
}

?>